#include "main.h"
#include "inet_aton.h"
#ifndef HAVE_ISASCII
#  define isascii(x)	1
#endif
#ifndef HAVE_INET_ATON
#if defined(LIBC_SCCS) && !defined(lint)
static char sccsid[] = "@(#)inet_addr.c	8.1 (Berkeley) 6/17/93";
static char rcsid[] = "$-Id: inet_addr.c,v 1.11 1999/04/29 18:19:53 drepper Exp $";
#endif

#include <sys/types.h>
#include <sys/param.h>
#include <ctype.h>

int
egg_inet_aton(cp, addr)
	const char *cp;
	struct in_addr *addr;
{
	static const u_32bit_t max[4] = { 0xffffffff, 0xffffff, 0xffff, 0xff };
	register u_32bit_t val;
	register int base;
	register int n;
	register char c;
	u_32bit_t parts[4];
	register u_32bit_t *pp = parts;

	egg_bzero(parts, sizeof (parts));

	c = *cp;
	for (;;) {
		if (!isdigit(c))
			goto ret_0;
		base = 10;
		if (c == '0') {
			c = *++cp;
			if (c == 'x' || c == 'X')
				base = 16, c = *++cp;
			else
				base = 8;
		}
		val = 0;
		for (;;) {
			if (isascii(c) && isdigit(c)) {
				val = (val * base) + (c - '0');
				c = *++cp;
			} else if (base == 16 && isascii(c) && isxdigit(c)) {
				val = (val << 4) |
					(c + 10 - (islower(c) ? 'a' : 'A'));
				c = *++cp;
			} else
				break;
		}
		if (c == '.') {
			if (pp >= parts + 3)
				goto ret_0;
			*pp++ = val;
			c = *++cp;
		} else
			break;
	}
	if (c != '\0' && (!isascii(c) || !isspace(c)))
		goto ret_0;
	n = pp - parts + 1;

	if (n == 0
	    || parts[0] > 0xff || parts[1] > 0xff || parts[2] > 0xff
	    || val > max[n - 1])
	  goto ret_0;

	val |= (parts[0] << 24) | (parts[1] << 16) | (parts[2] << 8);

	if (addr)
		addr->s_addr = htonl(val);
	return (1);

ret_0:
	return (0);
}
#endif
